package com.yice.webadmin.app.service;

import com.yice.common.core.base.service.IBaseService;
import com.yice.webadmin.app.dto.RunPublishDto;
import com.yice.webadmin.app.model.ModelManage;
import com.yice.webadmin.app.model.ModelVersion;
import com.yice.webadmin.app.model.TuningRun;

import java.util.List;

/**
 * 精调任务运行数据操作服务接口。
 *
 * @author linking
 * @date 2023-04-13
 */
public interface TuningRunService extends IBaseService<TuningRun, Long> {

    /**
     * 保存新增对象。
     *
     * @param tuningRun 新增对象。
     * @return 返回新增对象。
     */
    TuningRun saveNew(TuningRun tuningRun);

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param tuningRunList 新增对象列表。
     */
    void saveNewBatch(List<TuningRun> tuningRunList);

    /**
     * 更新数据对象。
     *
     * @param tuningRun         更新的对象。
     * @param originalTuningRun 原有数据对象。
     * @return 成功返回true，否则false。
     */
    boolean update(TuningRun tuningRun, TuningRun originalTuningRun);

    /**
     * 删除指定数据。
     *
     * @param runId 主键Id。
     * @return 成功返回true，否则false。
     */
    boolean remove(Long runId);

    /**
     * 当前服务的支持表为从表，根据主表的关联Id，删除一对多的从表数据。
     *
     * @param taskId 从表关联字段。
     * @return 删除数量。
     */
    int removeByTaskId(Long taskId);

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getTuningRunListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    List<TuningRun> getTuningRunList(TuningRun filter, String orderBy);

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getTuningRunList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    List<TuningRun> getTuningRunListWithRelation(TuningRun filter, String orderBy);

    boolean publishToModelVersion(RunPublishDto runPublishDto);

    ModelManage createToModel(ModelManage modelManage, ModelVersion modelVersion);

    ModelVersion createToModelVersion(ModelVersion modelVersion);

    boolean updateStatusById(TuningRun tuningRun);
}
